## yadifa 3.0.0

=== CMakeLists.txt ===
################################################################################
#
# Copyright (c) 2011-2024, EURid vzw. All rights reserved.
# The YADIFA TM software product is provided under the BSD 3-clause license:
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
#        * Redistributions of source code must retain the above copyright
#          notice, this list of conditions and the following disclaimer.
#        * Redistributions in binary form must reproduce the above copyright
#          notice, this list of conditions and the following disclaimer in the
#          documentation and/or other materials provided with the distribution.
#        * Neither the name of EURid nor the names of its contributors may be
#          used to endorse or promote products derived from this software
#          without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
################################################################################

cmake_minimum_required(VERSION 3.22)

include(${CMAKE_SOURCE_DIR}/cmake/CheckCHeaders.cmake)
include(${CMAKE_SOURCE_DIR}/cmake/CheckCompilerFlags.cmake)
include(${CMAKE_SOURCE_DIR}/cmake/EURidToolbox.cmake)

read_version("3.0.0")

project(yadifa VERSION ${VERSION_TEXT} LANGUAGES C)

kvstatus("YADIFA version" "${VERSION_TEXT}")

if(WIN32)
set(BUILD_SHARED_LIBS OFF)
set(BUILD_STATIC_LIBS ON)
set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /STACK:8388608")
add_definitions(-DMICROSOFT_WINDOWS_WINBASE_H_DEFINE_INTERLOCKED_CPLUSPLUS_OVERLOADS=0)
endif()

set(IGNORE_GNU_INSTALL_DIRS false CACHE BOOL "Ignore the rules of setting-up the installation paths")

if(NOT IGNORE_GNU_INSTALL_DIRS)
include(GNUInstallDirs)
endif()

set(CMAKE_C_STANDARD 11)
#set(CMAKE_C_STANDARD 23)

include(${CMAKE_SOURCE_DIR}/cmake/FindOpenSSL.cmake)

set(CMAKE_VERBOSE_MAKEFILE ON)

check_self()
check_headers_files()
check_sockaddr_sin_len_field()
check_sockaddr_sin6_len_field()
check_c_compiler_flags()
check_memalign_issues()
if(UNIX)
check_gnu_source()
check_pthread_setname_np()
check_pthread_setaffinity_np()
check_pthread_spin_init()
check_gettid()
endif()
check_mremap()
check_timegm()
check_endianness()

# If we relase the cmake build, we cannot force the prefix to one of our owns.
#
#
# you must clear CMakeCache if you want to change this

#if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
#    set(CMAKE_INSTALL_PREFIX
#        "/registry/${PROJECT_NAME}-${PROJECT_VERSION}" CACHE PATH "${PROJECT_NAME} install prefix" FORCE
#    )
#endif()

################################################################################
#
#	PARAMETERS THAT CAN BE CHANGED
#
################################################################################

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/")

include(CTest) # must be included after EURidToolbox.cmake

set(YATEST_INCLUDE_DIRECTORY "${CMAKE_SOURCE_DIR}/tests")

# settings from subdirectories - START

set(PACKAGE "yadifa")
set(PACKAGE_VERSION "3.0.0")
set(VERSION "3.0.0")
set(PACKAGE_STRING "${PACKAGE} ${PACKAGE_VERSION}")
set(PACKAGE_BUGREPORT "bugreport@yadifa.eu")

set(CPACK_SOURCE_PACKAGE_FILE_NAME ${PACKAGE}-${PACKAGE_VERSION})
set(CPACK_SOURCE_IGNORE_FILES \.git.*;\.idea)
set(CPACK_SOURCE_GENERATOR "TGZ")

# please do not change these options
option_has(FILEPOOL_CACHE "DEVS: enable the user-level cache for the file pools" OFF)
option_has(DNSQ "DEVS: enable the code related to that project" OFF)
option_has_support(DROPALL "DEVS: Enable this test feature" OFF)
option_has_support(DYNCONF "DEVS: enable dynamic configuration" OFF)
option_has(EXPERIMENTAL "DEVS: Enable various experimental code" OFF)
option_has_support(MIRROR "DEVS: Enable this test feature" OFF)
option_has_support(NSEC "DEVS: enable NSEC support" ON)
option_has_support(NSEC3 "DEVS: enable NSEC3 support" ON)
option_has(RDTSC "DEVS: enable RDTSC usage for profiling" OFF)

set(NETWORK_INTERFACES_MAX 256)

mark_as_advanced(
        DNSQ
        DROPALL
        DYNCONF
        EXPERIMENTAL
        MIRROR
        NSEC
        NSEC3
        RDTSC
        )

option_has(DEBUG "Enable #if DEBUG code" OFF)

option_has_support(PRIMARY "Enable DNS primary code" ON)
option_has_support(DNSSEC "Enable DNSSEC support" ON)
option_has(CTRL "Enable remote control" ON)
option_has_support(NSID "Enable NSID support" ON)

option_has_support(ACL "Enable ACL support" ON)
option_has_support(RRL "Enable RRL support" ON)
option_has_support(TSIG "Enable TSIG support" ON)
option_has_support(DYNUPDATE "Enable dynamic update support" ON)
option_has_support(RRSIG_MANAGEMENT "Enable RRSIG verification and generation for zones" ON)
option_has_support(ZALLOC "Enable internal memory allocation support" ON)
option_has_support(ZALLOC_STATISTICS "Enable internal memory allocation statistics" OFF)
option_has_support(ZALLOC_DEBUG "Enable internal memory allocation debugging" OFF)
option_has_support(MMAP_DEBUG "Enable mmap debugging" OFF)
option_has_support(MALLOC_DEBUG "Enable heap memory allocation debugging" OFF)
option_has_support(LIBC_MALLOC_DEBUG "Enable libc malloc monitors" OFF)
option_has_support(BFD_DEBUG "Enable bfd debuging (symbol tables)" OFF)
option_has(QUERY_US_DEBUG "Measure query time in us" OFF)
option_has_support(MUTEX_DEBUG "Enable mutex debugging (insanely heavy)" OFF)
option_has_support(LOCK_DEBUG "Enable zone lock debugging (insanely heavy)" OFF)
option_has_support(TRACK_ZONES_DEBUG "Enable tracking of the instanciated zones for detecting potential leaks. Relatively cheap with a small (<100) amount of zones." OFF)
option_has(LOG_THREAD_ID "Enable a new column in the logs with an alphanumeric id consistent in the lowest 32 bits of the thread id sending the line" OFF)
option_has(LOG_THREAD_TAG "Enable a column with a 8 letters human-readable tag identifying a thread in each log line" ON)
option_has(LOG_PID "Enable a column with the pid in each line of log" ON)
option_has(FULL_ASCII7 "Enable acceptance of ASCII7 characters in DNS names (not recommended)" OFF)
option_has_support(ECDSA "Enable Elliptic Curve (ECDSA) support" ON)
if(NOT CMAKE_HOST_SYSTEM_NAME MATCHES "OpenBSD")
    option_has_support(EDDSA "Enable Edwards Curve (EDDSA) support" ON)
endif()
option(OPENSSL_DIRECTORY "Sets the installation directory of OPENSSL (default: autodetects)" "")

option_has_support(NON_AA_AXFR "Enable lenient acceptance of AXFR answer from primary that do not have AA bit set (Microsoft DNS)" OFF)
option_has(SYSTEMD_RESOLVED_AVOIDANCE "If set, yadifad will set do-not-listen to \"127.0.0.53 port 53\" by default (otherwise the list is empty)" OFF)
option_has(EVENT_DYNAMIC_MODULE "Enable Adds support for dynamically loaded module that gets events from yadifad and is allowed to fetch some information from the daemon (EXPERIMENTAL)" OFF)
option_has(TCL "Enable TCL support" OFF)
option_has(BUILD_TIMESTAMP "Set to ON to disable the build timestamp" OFF)
option_has(TCP_MANAGER "If set, the TCP manager will be enabled and used to handle TCP quotas" ON) # do NOT turn off
option_has(LOGGING_DISABLED "If set, the logging macros are no-operations. This is useful for coverage." OFF)
option_has_support(DNS_OVER_TLS "If set, yadifad will support DNS over TLS (experimental)" ON)
option_has_support(OQS "If set, yadifad will support experimental post-quantum-safe algorithms" OFF)

option_path(OPENSSL_DIRECTORY "Set to the path of openssl" "")

option_has(GCC_HARDENED "Adds build options for GCC" OFF)

# some 'has_XXX' for YADIFA binary

#option_has(YADIFA              "controler for 'yadifad'"           ON) # HAS_CTRL is already defined
option_has(DNSSEC_TOOL         "replacement of BIND dnssec-tools"  ON)
option_has(DNS_CONFIG_CHECKER  "checks YADIFA config"             OFF)
option_has(YADIG               "replacement of BIND dig"           ON)

# still experimental stuff
# this is stuff needed when we have a WHOIS plugin
option_has(WHOIS               "for WHOIS plugin"                 OFF)
# this is stuff needed when we have a DNSQ plugin
option_has(DNSQ                "for DNSQ plugin"                  OFF)

option_set(TOOLS "Enable the tools" ON)

option_set(BUILD_SHARED_LIBS "Build shared libraries" ON)
option_set(BUILD_STATIC_LIBS "Build static libraries" OFF)
option_set(WITH_COVERAGE "Builds with -fprofile-arcs and -ftest-coverage" OFF)

kvstatus("OQS support" "${HAS_OQS_SUPPORT}")
if(${HAS_OQS_SUPPORT})
    include(${CMAKE_SOURCE_DIR}/cmake/FindOQS.cmake)
endif()

kvstatus("shared-build" "${BUILD_SHARED_LIBS}")
kvstatus("static-build" "${BUILD_STATIC_LIBS}")

#
# settings from subdirectories - END

# libraries can be compiled STATIC or SHARED

set(IS_DARWIN_OS                                 0)


if(NOT DEBUG)
    set(COMPILE_FOR_RELEASE                      1)
else()
    # you need to choose one of them, you can not switch on all of them
    # at the same time
    set(COMPILE_FOR_DEBUG                        1)
    set(COMPILE_FOR_PROFILE                      0)
endif()

set(CMAKE_HOST_UNIX                              1)

################################################################################
#
#       COLORIZE
#
################################################################################

if(NOT WIN32)
    message(STATUS "COLORIZE OUTPUT")
    string(ASCII 27 Esc)
    set(ColorReset  "${Esc}[m")
    set(ColorBold   "${Esc}[1m")
    set(Red         "${Esc}[31m")
    set(Green       "${Esc}[32m")
    set(Yellow      "${Esc}[33m")
    set(Blue        "${Esc}[34m")
    set(Magenta     "${Esc}[35m")
    set(Cyan        "${Esc}[36m")
    set(White       "${Esc}[37m")
    set(BoldRed     "${Esc}[1;31m")
    set(BoldGreen   "${Esc}[1;32m")
    set(BoldYellow  "${Esc}[1;33m")
    set(BoldBlue    "${Esc}[1;34m")
    set(BoldMagenta "${Esc}[1;35m")
    set(BoldCyan    "${Esc}[1;36m")
    set(BoldWhite   "${Esc}[1;37m")
endif()

###############################################################################
###############################################################################
##                                                                           ##
## DO NOT USE "PREFIX" AS FOR AUTOCONF/AUTOMAKE                              ##
##                                                                           ##
## DON'T : option(PREFIX "the installation prefix" ${CMAKE_INSTALL_PREFIX})  ##
##                                                                           ##
###############################################################################
###############################################################################

# Update back the options for GNUInstallDirs

if(IGNORE_GNU_INSTALL_DIRS)
set(CMAKE_INSTALL_FULL_SYSCONFDIR "${CMAKE_INSTALL_PREFIX}/etc" CACHE PATH "<prefix>/etc")
set(CMAKE_INSTALL_FULL_BINDIR "${CMAKE_INSTALL_PREFIX}/bin"  CACHE PATH "<prefix>/bin")
set(CMAKE_INSTALL_FULL_SBINDIR "${CMAKE_INSTALL_PREFIX}/sbin"  CACHE PATH "<prefix>/sbin")
set(CMAKE_INSTALL_FULL_LIBEXEC "${CMAKE_INSTALL_PREFIX}/libexec"  CACHE PATH "<prefix>/libexec")
set(CMAKE_INSTALL_FULL_LIBDIR "${CMAKE_INSTALL_PREFIX}/lib"  CACHE PATH "<prefix>/lib")

=== doc/CMakeLists.txt ===
################################################################################
#
# Copyright (c) 2011-2024, EURid vzw. All rights reserved.
# The YADIFA TM software product is provided under the BSD 3-clause license:
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
#        * Redistributions of source code must retain the above copyright
#          notice, this list of conditions and the following disclaimer.
#        * Redistributions in binary form must reproduce the above copyright
#          notice, this list of conditions and the following disclaimer in the
#          documentation and/or other materials provided with the distribution.
#        * Neither the name of EURid nor the names of its contributors may be
#          used to endorse or promote products derived from this software
#          without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
################################################################################

cmake_minimum_required(VERSION 3.22)

################################################################################
#
#       INSTALLS
#
################################################################################

install(FILES yadifa.conf.man DESTINATION ${CMAKE_INSTALL_FULL_MANDIR}/man5 RENAME yadifa.conf.5 COMPONENT man)
install(FILES yadifa.rc.man DESTINATION ${CMAKE_INSTALL_FULL_MANDIR}/man5 RENAME yadifa.rc.5 COMPONENT man)
install(FILES yadifad.conf.man DESTINATION ${CMAKE_INSTALL_FULL_MANDIR}/man5 RENAME yadifad.conf.5 COMPONENT man)
install(FILES yakeyrolld.conf.man DESTINATION ${CMAKE_INSTALL_FULL_MANDIR}/man5 RENAME yakeyrolld.conf.5 COMPONENT man)

install(FILES yadifad.man DESTINATION ${CMAKE_INSTALL_FULL_MANDIR}/man8 RENAME yadifad.8 COMPONENT man)
install(FILES yadifa.man DESTINATION ${CMAKE_INSTALL_FULL_MANDIR}/man8 RENAME yadifa.8 COMPONENT man)
install(FILES yakeyrolld.man DESTINATION ${CMAKE_INSTALL_FULL_MANDIR}/man8 RENAME yakeyrolld.8 COMPONENT man)

=== etc/CMakeLists.txt ===
################################################################################
#
# Copyright (c) 2011-2024, EURid vzw. All rights reserved.
# The YADIFA TM software product is provided under the BSD 3-clause license:
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
#        * Redistributions of source code must retain the above copyright
#          notice, this list of conditions and the following disclaimer.
#        * Redistributions in binary form must reproduce the above copyright
#          notice, this list of conditions and the following disclaimer in the
#          documentation and/or other materials provided with the distribution.
#        * Neither the name of EURid nor the names of its contributors may be
#          used to endorse or promote products derived from this software
#          without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
################################################################################

cmake_minimum_required(VERSION 3.22)

################################################################################
#
#       INSTALLS
#
################################################################################

set(YADIFAD_CONF "yadifad.conf")
set(YADIFAD_CONF_EXAMPLE "${CMAKE_CURRENT_SOURCE_DIR}/${YADIFAD_CONF}.example")

set(YADIFA_CONF "yadifa.conf")
set(YADIFA_CONF_EXAMPLE "${CMAKE_CURRENT_SOURCE_DIR}/${YADIFA_CONF}.example")

set(KEYS_CONF "keys.conf")
set(KEYS_CONF_EXAMPLE "${CMAKE_CURRENT_SOURCE_DIR}/${KEYS_CONF}.example")

set(YADIFAD_INIT "yadifad.init")
set(YADIFAD_INIT_EXAMPLE "${CMAKE_CURRENT_SOURCE_DIR}/${YADIFAD_INIT}.example")
set(YADIFAD_SERVICE "yadifad.service")
set(YADIFAD_SERVICE_EXAMPLE "${CMAKE_CURRENT_SOURCE_DIR}/${YADIFAD_SERVICE}.example")

set(YADIFA "yadifa")
set(YADIFA_BASH_COMPLETION "${CMAKE_CURRENT_SOURCE_DIR}/${YADIFA}.bash_completion")
set(YADIFA_BASH_COMPLETION_GENERATED "${CMAKE_CURRENT_BINARY_DIR}/${YADIFA}.bash_completion")

set(YADIFAD "yadifad")
set(YADIFAD_BASH_COMPLETION "${CMAKE_CURRENT_SOURCE_DIR}/${YADIFAD}.bash_completion")
set(YADIFAD_BASH_COMPLETION_GENERATED "${CMAKE_CURRENT_BINARY_DIR}/${YADIFAD}.bash_completion")

set(YAKEYROLLD "yakeyrolld")
set(YAKEYROLLD_CONF "${YAKEYROLLD}.conf")
set(YAKEYROLLD_CONF_EXAMPLE "${CMAKE_CURRENT_SOURCE_DIR}/${YAKEYROLLD_CONF}.example")

set(BASH_COMPLETION_DIRECTOR "/etc/bash_completion.d/")

# note: LENGTH must be a multiple of 4
string(RANDOM LENGTH 24 ALPHABET "ABASH_COMPLETION_DIRECTORYDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/" RNDBASE64)

# YADIFAD_CONF
message("Generating ${CMAKE_CURRENT_BINARY_DIR}/${YADIFAD_CONF} from ${YADIFAD_CONF_EXAMPLE}")
file(STRINGS "${YADIFAD_CONF_EXAMPLE}" YADIFAD_CONF_EXAMPLE_CONTENT)
file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/${YADIFAD_CONF}" "")
foreach(SOURCE_LINE IN LISTS YADIFAD_CONF_EXAMPLE_CONTENT)
    string(REGEX REPLACE "(.*)/var/(.*)" "XXXMATCHXXX1${LOCALSTATEDIR}/XXXMATCHXXX2" TARGET_LINE "${SOURCE_LINE}")
    string(REPLACE "XXXMATCHXXX1" "${CMAKE_MATCH_1}" TARGET_LINE "${TARGET_LINE}")
    string(REPLACE "XXXMATCHXXX2" "${CMAKE_MATCH_2}" TARGET_LINE "${TARGET_LINE}")
    file(APPEND "${CMAKE_CURRENT_BINARY_DIR}/${YADIFAD_CONF}" "${TARGET_LINE}\n")
endforeach()

# YAKEYROLLD_CONF
message("Generating ${CMAKE_CURRENT_BINARY_DIR}/${YAKEYROLLD_CONF} from ${YAKEYROLLD_CONF_EXAMPLE}")
file(STRINGS "${YAKEYROLLD_CONF_EXAMPLE}" YAKEYROLLD_CONF_EXAMPLE_CONTENT)
file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/${YAKEYROLLD_CONF}" "")
foreach(SOURCE_LINE IN LISTS YAKEYROLLD_CONF_EXAMPLE_CONTENT)
    string(REGEX REPLACE "(.*)/var/(.*)" "XXXMATCHXXX1${LOCALSTATEDIR}/XXXMATCHXXX2" TARGET_LINE "${SOURCE_LINE}")
    string(REPLACE "XXXMATCHXXX1" "${CMAKE_MATCH_1}" TARGET_LINE "${TARGET_LINE}")
    string(REPLACE "XXXMATCHXXX2" "${CMAKE_MATCH_2}" TARGET_LINE "${TARGET_LINE}")
    file(APPEND "${CMAKE_CURRENT_BINARY_DIR}/${YAKEYROLLD_CONF}" "${TARGET_LINE}\n")
endforeach()

# YADIFA_CONF
configure_file("${YADIFA_CONF_EXAMPLE}" "${CMAKE_CURRENT_BINARY_DIR}/${YADIFA_CONF}" COPYONLY)

# KEYS_CONF
message("Generating ${CMAKE_CURRENT_BINARY_DIR}/${KEYS_CONF} from ${KEYS_CONF_EXAMPLE}")
file(STRINGS "${KEYS_CONF_EXAMPLE}" KEYS_CONF_EXAMPLE_CONTENT)
file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/${KEYS_CONF}" "")
foreach(SOURCE_LINE IN LISTS KEYS_CONF_EXAMPLE_CONTENT)
    string(REPLACE "ChangeThisKey" "${RNDBASE64}" TARGET_LINE "${SOURCE_LINE}")
    file(APPEND "${CMAKE_CURRENT_BINARY_DIR}/${KEYS_CONF}" "${TARGET_LINE}\n")
endforeach()

# YADIFAD_INIT
message("Generating ${CMAKE_CURRENT_BINARY_DIR}/${YADIFAD_INIT} from ${YADIFAD_INIT_EXAMPLE}")
file(STRINGS "${YADIFAD_INIT_EXAMPLE}" YADIFAD_INIT_EXAMPLE_CONTENT)
file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/${YADIFAD_INIT}" "")
foreach(SOURCE_LINE IN LISTS YADIFAD_INIT_EXAMPLE_CONTENT)
    string(REGEX REPLACE "^PREFIX=.*" "PREFIX=${PREFIX}" TARGET_LINE "${SOURCE_LINE}")
    file(APPEND "${CMAKE_CURRENT_BINARY_DIR}/${YADIFAD_INIT}" "${TARGET_LINE}\n")
endforeach()

# YADIFAD_SERVICE
message("Generating ${CMAKE_CURRENT_BINARY_DIR}/${YADIFAD_SERVICE} from ${YADIFAD_SERVICE_EXAMPLE}")
file(STRINGS "${YADIFAD_SERVICE_EXAMPLE}" YADIFAD_SERVICE_EXAMPLE_CONTENT)
file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/${YADIFAD_SERVICE}" "")
foreach(SOURCE_LINE IN LISTS YADIFAD_SERVICE_EXAMPLE_CONTENT)
    string(REGEX REPLACE "/usr/sbin" "${SBINDIR}" TARGET_LINE "${SOURCE_LINE}")
    string(REGEX REPLACE "/etc/yadifa" "${SYSCONFDIR}" TARGET_LINE "${TARGET_LINE}")
    string(REGEX REPLACE "/var" "${LOCALSTATE}" TARGET_LINE "${TARGET_LINE}")
    file(APPEND "${CMAKE_CURRENT_BINARY_DIR}/${YADIFAD_SERVICE}" "${TARGET_LINE}\n")
endforeach()

# YC
configure_file("${YADIFA_BASH_COMPLETION}" "${YADIFA_BASH_COMPLETION_GENERATED}" COPYONLY)

# YD
configure_file("${YADIFAD_BASH_COMPLETION}" "${YADIFAD_BASH_COMPLETION_GENERATED}" COPYONLY)

# The reason this overwrites already existing files is that these generated files are newer than the existing ones
#
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/${YADIFAD_CONF}" DESTINATION "${CMAKE_INSTALL_FULL_DOCDIR}" COMPONENT etc)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/${KEYS_CONF}" DESTINATION "${CMAKE_INSTALL_FULL_DOCDIR}" COMPONENT etc)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/${YADIFA_CONF}" DESTINATION "${CMAKE_INSTALL_FULL_DOCDIR}" COMPONENT etc)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/${YAKEYROLLD_CONF}" DESTINATION "${CMAKE_INSTALL_FULL_DOCDIR}" COMPONENT etc)

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/${YADIFAD_INIT}" DESTINATION "${CMAKE_INSTALL_FULL_DOCDIR}" COMPONENT etc)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/${YADIFAD_SERVICE}" DESTINATION "${CMAKE_INSTALL_FULL_DOCDIR}" COMPONENT etc)

install(FILES "${YADIFA_BASH_COMPLETION_GENERATED}" DESTINATION "${CMAKE_INSTALL_FULL_DOCDIR}" COMPONENT etc)
install(FILES "${YADIFAD_BASH_COMPLETION_GENERATED}" DESTINATION "${CMAKE_INSTALL_FULL_DOCDIR}" COMPONENT etc)

install(FILES
        "yadifad-primary.conf.example"
        "yadifad-secondary.conf.example"
        "yadifad.init.debian"
        "yadifad.init.rhel"
        "yadifad.logrotate"
        "yadifad.service.arch"
        "yadifad.service.debian"
        "yadifad.service.rhel"
        "yakeyrolld.conf.example"
        DESTINATION "${CMAKE_INSTALL_FULL_DOCDIR}" COMPONENT etc)

install(DIRECTORY DESTINATION ${CMAKE_INSTALL_FULL_SYSCONFDIR})
install(CODE
        "
        #file(TOUCH \"${CMAKE_INSTALL_FULL_SYSCONFDIR}/yadifa.conf\")
        file(TOUCH \"${CMAKE_INSTALL_FULL_SYSCONFDIR}/yadifad.conf\")
        file(TOUCH \"${CMAKE_INSTALL_FULL_SYSCONFDIR}/yakeyrolld.conf\")
        ")

=== tests/CMakeLists.txt ===
################################################################################
#
# Copyright (c) 2011-2024, EURid vzw. All rights reserved.
# The YADIFA TM software product is provided under the BSD 3-clause license:
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
#        * Redistributions of source code must retain the above copyright
#          notice, this list of conditions and the following disclaimer.
#        * Redistributions in binary form must reproduce the above copyright
#          notice, this list of conditions and the following disclaimer in the
#          documentation and/or other materials provided with the distribution.
#        * Neither the name of EURid nor the names of its contributors may be
#          used to endorse or promote products derived from this software
#          without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
################################################################################

add_subdirectory(circular-file-test)
add_subdirectory(cjf-scan)
add_subdirectory(cmdline-test)
add_subdirectory(collection-test)
if(NOT WIN32)
#add_subdirectory(cwisstable-test)
endif()
add_subdirectory(daemonised-logger-test)
add_subdirectory(dns-message-test)
add_subdirectory(dnssec-test)
#add_subdirectory(dnsserver-test)
#add_subdirectory(dns-pcap-analyser)
#add_subdirectory(dns-query-tcp)
add_subdirectory(dsfromkey-test)
add_subdirectory(ethbenchprobe)
#add_subdirectory(filepool-test)
add_subdirectory(file-test)
#add_subdirectory(futex-test)
#add_subdirectory(hash-test)
add_subdirectory(hmac-test)
if(UNIX)
add_subdirectory(ipc-test)
endif()
add_subdirectory(journal-from-ixfr)
add_subdirectory(journal-fusion)
#add_subdirectory(journal-server)
add_subdirectory(journal-speed-test)
#add_subdirectory(json-test)
add_subdirectory(keygen-test)
add_subdirectory(limiter-test)
#add_subdirectory(logger-test)
add_subdirectory(message-test)
#add_subdirectory(mutex-test)
add_subdirectory(network-interfaces-forall-test)
add_subdirectory(notify-test)
add_subdirectory(nsec3-answer)
add_subdirectory(nsec3-hash)
#add_subdirectory(parser-test)
add_subdirectory(pid-file-test)
add_subdirectory(protocol-test)
add_subdirectory(query-hammer-test)
#add_subdirectory(random-test)
add_subdirectory(rndc-test)
add_subdirectory(rrsig-test)
add_subdirectory(shared-circular-buffer-test)
add_subdirectory(shared-heap-test)
add_subdirectory(simple-http-server-test)
#add_subdirectory(skeleton)
#add_subdirectory(ssl3-test)
add_subdirectory(stream-test)
add_subdirectory(tag-gen)
#add_subdirectory(tcp-manager-test)
add_subdirectory(threaded-queue)
#add_subdirectory(tsig-test)
add_subdirectory(udp-echo-test)
add_subdirectory(update-test)
#add_subdirectory(xfr)
#add_subdirectory(zone-rev)
add_subdirectory(zone-save-test)
#add_subdirectory(zone-verify-test)
#add_subdirectory(zoneread-test)
#add_subdirectory(zonediff-test)
if(UNIX AND NOT APPLE)
#add_subdirectory(openssl111a-ecdsa-test)
#add_subdirectory(openssl111a-eddsa-test)
add_subdirectory(freebsd12-test)
#add_subdirectory(axfr-intr-hammer)
endif()

=== var/CMakeLists.txt ===
################################################################################
#
# Copyright (c) 2011-2024, EURid vzw. All rights reserved.
# The YADIFA TM software product is provided under the BSD 3-clause license:
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
#        * Redistributions of source code must retain the above copyright
#          notice, this list of conditions and the following disclaimer.
#        * Redistributions in binary form must reproduce the above copyright
#          notice, this list of conditions and the following disclaimer in the
#          documentation and/or other materials provided with the distribution.
#        * Neither the name of EURid nor the names of its contributors may be
#          used to endorse or promote products derived from this software
#          without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
################################################################################

cmake_minimum_required(VERSION 3.22)

message("var will be installed in ${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/var")

install(DIRECTORY DESTINATION ${CMAKE_INSTALL_FULL_LOCALSTATEDIR})
install(DIRECTORY DESTINATION ${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/log)
install(DIRECTORY DESTINATION ${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/log/yadifa)
install(DIRECTORY DESTINATION ${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/log/yadifad)
install(DIRECTORY DESTINATION ${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/log/yakeyrolld)
install(DIRECTORY DESTINATION ${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/plans)
install(DIRECTORY DESTINATION ${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/run)
install(DIRECTORY DESTINATION ${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/zones)
install(DIRECTORY DESTINATION ${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/zones/keys)
install(DIRECTORY DESTINATION ${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/zones/primaries)
install(DIRECTORY DESTINATION ${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/zones/secondaries)
install(DIRECTORY DESTINATION ${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/zones/xfr)

install(FILES   zones/primaries/0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.ip6.arpa.zone
                zones/primaries/0.0.127.in-addr.arpa.zone
                zones/primaries/localhost6.zone
                zones/primaries/localhost.zone
                zones/primaries/somedomain.eu.zone
        DESTINATION ${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/zones/primaries)

=== bin/yadifa/CMakeLists.txt ===
################################################################################
#
# Copyright (c) 2011-2024, EURid vzw. All rights reserved.
# The YADIFA TM software product is provided under the BSD 3-clause license:
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
#        * Redistributions of source code must retain the above copyright
#          notice, this list of conditions and the following disclaimer.
#        * Redistributions in binary form must reproduce the above copyright
#          notice, this list of conditions and the following disclaimer in the
#          documentation and/or other materials provided with the distribution.
#        * Neither the name of EURid nor the names of its contributors may be
#          used to endorse or promote products derived from this software
#          without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
################################################################################

cmake_minimum_required(VERSION 3.22)

project(yadifa LANGUAGES C)


################################################################################
#
#       GLOBAL SETTINGS
#
################################################################################

set(PACKAGE "yadifa")

message(STATUS "start making                      : yadifa")

option_has(CTRL "command line control module" true)
option_has(CRAFT "command line craft module (DO NOT RELEASE)" false)
option_has(YADIG "command line query module" true)
option_has(ZONESIGN "command line zone signing module" true)
option_has(KEYGEN "command line key generation module" true)

################################################################################
#
#       SOURCES
#
################################################################################

set(YADIFA_SOURCES
    main.c
    query_result.c
)

set(YADIFA_HEADERS
    main.h
    client_error.h
    common_config.h
    query_result.h
)

set(YADIFA_SOURCES
   ${YADIFA_SOURCES}
   common.c
   module.c
   ya_conf.c
)

set(YADIFA_HEADERS
    ${YADIFA_HEADERS}
    common.h
    module.h
    ya_conf.h
)

if(HAS_ZONESIGN)
    message("yadifa zonesign command")

    set(YADIFA_SOURCES
            ${YADIFA_SOURCES}
            module/zonesign.c
            )

    set(YADIFA_HEADERS
            ${YADIFA_HEADERS}
            module/zonesign.h
            )
endif()

kvstatus("HAS_ZONESIGN" "${HAS_ZONESIGN}")

if(HAS_KEYGEN)
    message("yadifa keygen command")

    set(YADIFA_SOURCES
            ${YADIFA_SOURCES}
            module/keygen.c
            )

    set(YADIFA_HEADERS
            ${YADIFA_HEADERS}
            module/keygen.h
            )
endif()

kvstatus("HAS_KEYGEN" "${HAS_KEYGEN}")

if(HAS_CTRL)
    message("yadifa ctrl command")

    set(YADIFA_SOURCES
        ${YADIFA_SOURCES}
        module/ctrl.c
    )

    set(YADIFA_HEADERS
        ${YADIFA_HEADERS}
        module/ctrl.h
    )
endif()

kvstatus("HAS_CTRL" "${HAS_CTRL}")

if(HAS_CRAFT)
    message("yadifa craft command")

    set(YADIFA_SOURCES
            ${YADIFA_SOURCES}
            module/craft.c
            )

    set(YADIFA_HEADERS
            ${YADIFA_HEADERS}
            module/craft.h
            )
endif()

kvstatus("HAS_CRAFT" "${HAS_CRAFT}")

if(HAS_YADIG)
    message("yadifa yadig command")

    set(YADIFA_SOURCES
        ${YADIFA_SOURCES}
        module/yadig.c
    )

    set(YADIFA_HEADERS
        ${YADIFA_HEADERS}
        module/yadig.h
    )
endif()

kvstatus("HAS_YADIG" "${HAS_YADIG}")

if(HAS_DNS_CONFIG_CHECKER)
    set(YADIFA_SOURCES
        ${YADIFA_SOURCES}
        module/dns_config_checker.c
    )

    set(YADIFA_HEADERS
        ${YADIFA_HEADERS}
        module/dns_config_checker.h
    )
endif()

kvstatus("HAS_DNS_CONFIG_CHECKER" "${HAS_DNS_CONFIG_CHECKER}")

if(HAS_DNSSEC_TOOL)
    message("yadifa dnssec command")

    set(YADIFA_SOURCES
        ${YADIFA_SOURCES}
        module/dnssec_tool.c
    )

    set(YADIFA_HEADERS
        ${YADIFA_HEADERS}
        module/dnssec_tool.h
    )
endif()
kvstatus("HAS_DNSSEC_TOOL" "${HAS_DNSSEC_TOOL}")

kvstatus("HAS_DNSQ" "${HAS_DNSQ}")

if(HAS_EXPERIMENTAL)
    set(YADIFA_SOURCES
        ${YADIFA_SOURCES}
        dnssec_test.c
    )

    set(YADIFA_HEADERS
        ${YADIFA_HEADERS}
        dnssec_test.h
    )
endif()
kvstatus("HAS_EXPERIMENTAL" "${HAS_EXPERIMENTAL}")

configure_file(client_config.h.cmake.in client_config.h)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})

################################################################################
#
#       SEARCH EXTERNAL LIBRARIES
#
################################################################################

# yadifa needs:
#   - dnscore
#   - dnsdb
#   - dnszone
#   - dnslg
#
# maybe:
#   - dnstcl
#

# add headers of yadifad libraries in the search path
include_directories("${CMAKE_SOURCE_DIR}/lib/dnscore/include")
include_directories("${CMAKE_BINARY_DIR}/lib/dnscore/include")
include_directories("${CMAKE_SOURCE_DIR}/lib/dnsdb/include")
include_directories("${CMAKE_BINARY_DIR}/lib/dnsdb/include")
include_directories("${CMAKE_SOURCE_DIR}/lib/dnslg/include")
include_directories("${CMAKE_BINARY_DIR}/lib/dnslg/include")

if(HAS_TCL)
    include_directories("${CMAKE_SOURCE_DIR}/lib/dnstcl/include")
    include_directories("${CMAKE_BINARY_DIR}/lib/dnstcl/include")
else()
#
endif()

buildinfo_file("${CMAKE_BINARY_DIR}/lib/dnsdb/include/buildinfo.h")

kvstatus("HAS_TCL IN YADIFA" "${HAS_TCL}\n")
if(HAS_TCL)
    # if 'Tcl' found
    find_package(Tcl REQUIRED)
    include_directories("${CMAKE_SOURCE_DIR}/lib/dnstcl/include")

    set(YADIFA_LIBRARIES_DEPS ${YADIFA_LIBRARIES} dnstcl  ${TCL_LIB})
else()
    set(YADIFA_LIBRARIES_DEPS ${YADIFA_LIBRARIES})
endif()

# this is only to check the include path if there are some issues
# no need to add libcrypto and libssl in the linking this is done with dnscore
# find_package(Openssl REQUIRED)

################################################################################
#
#       BUILD
#
################################################################################

add_executable(yadifa ${YADIFA_SOURCES} ${YADIFA_HEADERS})

# link it with other libraries
#     - from YADIFA 'dnscore'
#     - from YADIFA 'db'
#     - from YADIFA 'dnslg'
#     - from YADIFA 'dnstcl' (maybe)

target_link_libraries(yadifa PUBLIC ${DNSLGLIB_NAME} ${DNSDBLIB_NAME} ${DNSCORELIB_NAME})

message(STATUS "making yadifa done\n")

################################################################################
#
#       INSTALLS
#
################################################################################

kvmessage("install" "yadifa")
install(TARGETS yadifa RUNTIME DESTINATION "${CMAKE_INSTALL_FULL_BINDIR}")

=== lib/dnscore/CMakeLists.txt ===
################################################################################
#
# Copyright (c) 2011-2024, EURid vzw. All rights reserved.
# The YADIFA TM software product is provided under the BSD 3-clause license:
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
#        * Redistributions of source code must retain the above copyright
#          notice, this list of conditions and the following disclaimer.
#        * Redistributions in binary form must reproduce the above copyright
#          notice, this list of conditions and the following disclaimer in the
#          documentation and/or other materials provided with the distribution.
#        * Neither the name of EURid nor the names of its contributors may be
#          used to endorse or promote products derived from this software
#          without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
################################################################################

cmake_minimum_required(VERSION 3.22)
include(${CMAKE_SOURCE_DIR}/cmake/EURidToolbox.cmake)

project(dnscore LANGUAGES C)
set(CMAKE_C_STANDARD 11)
set(LIBRARY_SO_VERSION                       10.0.0)
set(LIBRARY_SO_MAJOR                             10)

set(PACKAGE "dnscore")

kvstatus("building" "${PACKAGE}")

add_definitions(-DDNSCORE_BUILD)

################################################################################
#
#       SOURCES
#
################################################################################

set(LIBRARY_SOURCE_PATH "src")
set(LIBRARY_HEADER_PATH "include/dnscore")
set(LIBRARY_CONFIG_FILE "dnscore_config.h")
set(LIBRARY_FEATURES_FILE "dnscore_config_features.h")
set(LIBRARY_FEATURES_PREFIX "DNSCORE_")

set(LIBRARY_SOURCES
    ${LIBRARY_SOURCE_PATH}/acl.c
    ${LIBRARY_SOURCE_PATH}/acl_config.c
    ${LIBRARY_SOURCE_PATH}/alarm.c
    #${LIBRARY_SOURCE_PATH}/allocator.c
    ${LIBRARY_SOURCE_PATH}/async.c
    ${LIBRARY_SOURCE_PATH}/base16.c
    ${LIBRARY_SOURCE_PATH}/base32.c
    ${LIBRARY_SOURCE_PATH}/base32hex.c
    ${LIBRARY_SOURCE_PATH}/base64.c
    ${LIBRARY_SOURCE_PATH}/basic_priority_queue.c
    ${LIBRARY_SOURCE_PATH}/buffer_input_stream.c
    ${LIBRARY_SOURCE_PATH}/buffer_output_stream.c
    ${LIBRARY_SOURCE_PATH}/buffered_file.c
    ${LIBRARY_SOURCE_PATH}/bytearray_input_stream.c
    ${LIBRARY_SOURCE_PATH}/bytearray_output_stream.c
    ${LIBRARY_SOURCE_PATH}/bytezarray_output_stream.c
    ${LIBRARY_SOURCE_PATH}/cache.c
    ${LIBRARY_SOURCE_PATH}/checked_output_stream.c
    ${LIBRARY_SOURCE_PATH}/circular_file.c
    ${LIBRARY_SOURCE_PATH}/clone_input_output_stream.c
    ${LIBRARY_SOURCE_PATH}/cmdline.c
    ${LIBRARY_SOURCE_PATH}/concat_input_stream.c
    ${LIBRARY_SOURCE_PATH}/config_cmdline.c
    ${LIBRARY_SOURCE_PATH}/config_file_reader.c
    ${LIBRARY_SOURCE_PATH}/config_key.c
    ${LIBRARY_SOURCE_PATH}/config_logger.c
    ${LIBRARY_SOURCE_PATH}/config_settings.c
    ${LIBRARY_SOURCE_PATH}/config_struct.c
    ${LIBRARY_SOURCE_PATH}/counter_output_stream.c
    ${LIBRARY_SOURCE_PATH}/crypto.c
    ${LIBRARY_SOURCE_PATH}/crc32.c
    ${LIBRARY_SOURCE_PATH}/debug.c
    ${LIBRARY_SOURCE_PATH}/debug_bench.c
    ${LIBRARY_SOURCE_PATH}/debug_bfd.c
    ${LIBRARY_SOURCE_PATH}/debug_malloc.c
    ${LIBRARY_SOURCE_PATH}/debug_mmap.c
    ${LIBRARY_SOURCE_PATH}/debug_stacktrace.c
    ${LIBRARY_SOURCE_PATH}/digest_rawdata.c
    ${LIBRARY_SOURCE_PATH}/dns_udp.c
    ${LIBRARY_SOURCE_PATH}/dns_message_verify_rrsig.c
    ${LIBRARY_SOURCE_PATH}/dns_message_writer_dig.c
    ${LIBRARY_SOURCE_PATH}/dns_message_writer_json.c
    ${LIBRARY_SOURCE_PATH}/dns_message_writer_easyparse.c
    ${LIBRARY_SOURCE_PATH}/dns_resource_record.c
    ${LIBRARY_SOURCE_PATH}/dnscore.c
    ${LIBRARY_SOURCE_PATH}/dnscore_extension.c
    ${LIBRARY_SOURCE_PATH}/dnsformat.c
    ${LIBRARY_SOURCE_PATH}/dnskey.c
    ${LIBRARY_SOURCE_PATH}/dnskey_keyring.c
    ${LIBRARY_SOURCE_PATH}/dnskey_eddsa.c
    ${LIBRARY_SOURCE_PATH}/dnskey_signature.c
    ${LIBRARY_SOURCE_PATH}/dnsname.c
    ${LIBRARY_SOURCE_PATH}/empty_input_stream.c
    ${LIBRARY_SOURCE_PATH}/error_state.c
    ${LIBRARY_SOURCE_PATH}/fdtools.c
    ${LIBRARY_SOURCE_PATH}/file_input_stream.c
    ${LIBRARY_SOURCE_PATH}/file_mtime_set.c
    ${LIBRARY_SOURCE_PATH}/file_output_stream.c
    ${LIBRARY_SOURCE_PATH}/file_pool.c
    ${LIBRARY_SOURCE_PATH}/filesystem_file.c
    ${LIBRARY_SOURCE_PATH}/format.c
    ${LIBRARY_SOURCE_PATH}/hash.c
    ${LIBRARY_SOURCE_PATH}/hash_table_values.c
    ${LIBRARY_SOURCE_PATH}/host_address.c
    #${LIBRARY_SOURCE_PATH}/hsdllist.c
    ${LIBRARY_SOURCE_PATH}/http_chunk_output_stream.c
    ${LIBRARY_SOURCE_PATH}/identity.c
    ${LIBRARY_SOURCE_PATH}/initialise_state.c
    ${LIBRARY_SOURCE_PATH}/input_stream.c
    #${LIBRARY_SOURCE_PATH}/ipc.c
    ${LIBRARY_SOURCE_PATH}/json.c
    ${LIBRARY_SOURCE_PATH}/limited_input_stream.c
    ${LIBRARY_SOURCE_PATH}/limiter.c
    ${LIBRARY_SOURCE_PATH}/list_dl.c
    ${LIBRARY_SOURCE_PATH}/list_dl_nodata.c
    ${LIBRARY_SOURCE_PATH}/list_sl.c
    ${LIBRARY_SOURCE_PATH}/list_sl_debug.c
    ${LIBRARY_SOURCE_PATH}/logger_output_stream.c
    ${LIBRARY_SOURCE_PATH}/logger.c
    ${LIBRARY_SOURCE_PATH}/logger_channel_file.c
    ${LIBRARY_SOURCE_PATH}/logger_channel_stream.c
    ${LIBRARY_SOURCE_PATH}/logger_channel_syslog.c
    ${LIBRARY_SOURCE_PATH}/logger_handle.c
    ${LIBRARY_SOURCE_PATH}/mapped_file.c
    ${LIBRARY_SOURCE_PATH}/dns_message.c
    ${LIBRARY_SOURCE_PATH}/dns_message_writer.c
    ${LIBRARY_SOURCE_PATH}/dns_message_update.c
    ${LIBRARY_SOURCE_PATH}/mt_output_stream.c
    ${LIBRARY_SOURCE_PATH}/mutex.c
    ${LIBRARY_SOURCE_PATH}/mutex_contention_monitor.c
    ${LIBRARY_SOURCE_PATH}/mutex_debug.c
    ${LIBRARY_SOURCE_PATH}/mutex_futex.c
    ${LIBRARY_SOURCE_PATH}/mutex_group.c
    ${LIBRARY_SOURCE_PATH}/mutex_mutex.c
    ${LIBRARY_SOURCE_PATH}/mutex_shared_group.c
    ${LIBRARY_SOURCE_PATH}/network.c
    #${LIBRARY_SOURCE_PATH}/name.c
    ${LIBRARY_SOURCE_PATH}/nsec3_hash.c
    ${LIBRARY_SOURCE_PATH}/output_stream.c
    ${LIBRARY_SOURCE_PATH}/pace.c
    ${LIBRARY_SOURCE_PATH}/dns_packet_reader.c
    ${LIBRARY_SOURCE_PATH}/dns_packet_writer.c
    ${LIBRARY_SOURCE_PATH}/parser.c
    ${LIBRARY_SOURCE_PATH}/parsing.c
    ${LIBRARY_SOURCE_PATH}/pcg_basic.c
    ${LIBRARY_SOURCE_PATH}/permut.c
    ${LIBRARY_SOURCE_PATH}/process.c
    ${LIBRARY_SOURCE_PATH}/pid.c
    ${LIBRARY_SOURCE_PATH}/pipe_stream.c
    ${LIBRARY_SOURCE_PATH}/pool.c
    ${LIBRARY_SOURCE_PATH}/ptr_treeset.c
    ${LIBRARY_SOURCE_PATH}/ptr_treeset_debug.c
    ${LIBRARY_SOURCE_PATH}/ptr_treemap.c
    ${LIBRARY_SOURCE_PATH}/ptr_treemap_debug.c
    ${LIBRARY_SOURCE_PATH}/ptr_vector.c
    ${LIBRARY_SOURCE_PATH}/pushback_input_stream.c
    ${LIBRARY_SOURCE_PATH}/queue_sl.c
    ${LIBRARY_SOURCE_PATH}/random.c
    ${LIBRARY_SOURCE_PATH}/rest_client.c
    ${LIBRARY_SOURCE_PATH}/rest_server.c
    ${LIBRARY_SOURCE_PATH}/rewind_input_stream.c
    ${LIBRARY_SOURCE_PATH}/rfc.c
    ${LIBRARY_SOURCE_PATH}/rndc.c
    ${LIBRARY_SOURCE_PATH}/serial.c
    ${LIBRARY_SOURCE_PATH}/server_setup.c
    ${LIBRARY_SOURCE_PATH}/service.c
    ${LIBRARY_SOURCE_PATH}/shared_heap.c
    ${LIBRARY_SOURCE_PATH}/shared_circular_buffer.c
    ${LIBRARY_SOURCE_PATH}/shared_heap_bytearray_output_stream.c
    ${LIBRARY_SOURCE_PATH}/signals.c
    ${LIBRARY_SOURCE_PATH}/simple_http_server.c
    ${LIBRARY_SOURCE_PATH}/socket_server.c
    ${LIBRARY_SOURCE_PATH}/ssl_input_output_stream.c
    ${LIBRARY_SOURCE_PATH}/string_set.c
    ${LIBRARY_SOURCE_PATH}/sys_error.c
    ${LIBRARY_SOURCE_PATH}/sys_get_cpu_count.c
    ${LIBRARY_SOURCE_PATH}/tcp_io_stream.c
    ${LIBRARY_SOURCE_PATH}/tcp_manager2.c
    ${LIBRARY_SOURCE_PATH}/tcp_manager_channel_ssl_context.c
    ${LIBRARY_SOURCE_PATH}/thread_pool.c
    ${LIBRARY_SOURCE_PATH}/thread.c
    ${LIBRARY_SOURCE_PATH}/thread_tag.c
    ${LIBRARY_SOURCE_PATH}/threaded_qsl_cw.c
    ${LIBRARY_SOURCE_PATH}/threaded_dll_cw.c
    ${LIBRARY_SOURCE_PATH}/threaded_nbrb.c
    ${LIBRARY_SOURCE_PATH}/threaded_queue_slg.c
    ${LIBRARY_SOURCE_PATH}/threaded_ringbuffer_cw.c
    ${LIBRARY_SOURCE_PATH}/timeformat.c
    ${LIBRARY_SOURCE_PATH}/timems.c
    ${LIBRARY_SOURCE_PATH}/tools.c
    ${LIBRARY_SOURCE_PATH}/typebitmap.c
    ${LIBRARY_SOURCE_PATH}/u32_treeset.c
    ${LIBRARY_SOURCE_PATH}/u64_treeset.c
    ${LIBRARY_SOURCE_PATH}/u64_treeset_debug.c
    ${LIBRARY_SOURCE_PATH}/u32_treemap.c
    ${LIBRARY_SOURCE_PATH}/u64_treemap.c
    ${LIBRARY_SOURCE_PATH}/uri.c
    ${LIBRARY_SOURCE_PATH}/utf8.c
    ${LIBRARY_SOURCE_PATH}/xfr_input_stream.c
    ${LIBRARY_SOURCE_PATH}/zalloc.c
    ${LIBRARY_SOURCE_PATH}/zone_reader_axfr.c
    ${LIBRARY_SOURCE_PATH}/zone_reader_text.c
)

if(NOT WIN32)
    if(OPENSSL_VERSION_MAJOR LESS 3)
        message("using libssl < 3.0 API")
        set(LIBRARY_SOURCES ${LIBRARY_SOURCES}
            #${LIBRARY_SOURCE_PATH}/dnskey_dsa.c
            ${LIBRARY_SOURCE_PATH}/dnskey_ecdsa.c
            ${LIBRARY_SOURCE_PATH}/dnskey_rsa.c
            ${LIBRARY_SOURCE_PATH}/digest_sha1.c
            ${LIBRARY_SOURCE_PATH}/digest_sha256.c
            ${LIBRARY_SOURCE_PATH}/digest_sha384.c
            ${LIBRARY_SOURCE_PATH}/digest_sha512.c
            ${LIBRARY_SOURCE_PATH}/hmac_openssl.c)
    else()
        message("using libssl >= 3.0 API")
        set(LIBRARY_SOURCES ${LIBRARY_SOURCES}
            ${LIBRARY_SOURCE_PATH}/dnskey_evp.c
            #${LIBRARY_SOURCE_PATH}/dnskey_evp_dsa.c
            ${LIBRARY_SOURCE_PATH}/dnskey_evp_ecdsa.c
            ${LIBRARY_SOURCE_PATH}/dnskey_evp_rsa.c
            ${LIBRARY_SOURCE_PATH}/digest_evp.c
            ${LIBRARY_SOURCE_PATH}/hmac_evp.c)
    endif()
    set(LIBRARY_SOURCES ${LIBRARY_SOURCES} ${LIBRARY_SOURCE_PATH}/digest_md5_internal.c)
else()
    message("using libssl >= 3.0 API")
    set(LIBRARY_SOURCES ${LIBRARY_SOURCES}
        ${LIBRARY_SOURCE_PATH}/dnskey_evp.c
        #${LIBRARY_SOURCE_PATH}/dnskey_evp_dsa.c
        ${LIBRARY_SOURCE_PATH}/dnskey_evp_ecdsa.c
        ${LIBRARY_SOURCE_PATH}/dnskey_evp_rsa.c
        ${LIBRARY_SOURCE_PATH}/digest_evp.c
        ${LIBRARY_SOURCE_PATH}/hmac_evp.c)
endif()

set(LIBRARY_HEADERS
    ${LIBRARY_HEADER_PATH}/acl.h
    ${LIBRARY_HEADER_PATH}/acl_config.h
    ${LIBRARY_HEADER_PATH}/alarm.h
    #${LIBRARY_HEADER_PATH}/allocator.h
    ${LIBRARY_HEADER_PATH}/async.h
    ${LIBRARY_HEADER_PATH}/avl.c.inc
    ${LIBRARY_HEADER_PATH}/avl.h.inc
    ${LIBRARY_HEADER_PATH}/base16.h
    ${LIBRARY_HEADER_PATH}/base32.h
    ${LIBRARY_HEADER_PATH}/base32hex.h
    ${LIBRARY_HEADER_PATH}/base64.h
    ${LIBRARY_HEADER_PATH}/basic_priority_queue.h
    ${LIBRARY_HEADER_PATH}/buffer_input_stream.h
    ${LIBRARY_HEADER_PATH}/buffer_output_stream.h
    ${LIBRARY_HEADER_PATH}/buffered_file.h
    ${LIBRARY_HEADER_PATH}/bytearray_input_stream.h
    ${LIBRARY_HEADER_PATH}/bytearray_output_stream.h
    ${LIBRARY_HEADER_PATH}/bytezarray_output_stream.h
    ${LIBRARY_HEADER_PATH}/cache.h
    ${LIBRARY_HEADER_PATH}/checked_output_stream.h
    ${LIBRARY_HEADER_PATH}/circular_file.h
    ${LIBRARY_HEADER_PATH}/clone_input_output_stream.h
    ${LIBRARY_HEADER_PATH}/cmdline.h
    ${LIBRARY_HEADER_PATH}/concat_input_stream.h
    ${LIBRARY_HEADER_PATH}/config_cmdline.h

=== lib/dnsdb/CMakeLists.txt ===
################################################################################
#
# Copyright (c) 2011-2024, EURid vzw. All rights reserved.
# The YADIFA TM software product is provided under the BSD 3-clause license:
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
#        * Redistributions of source code must retain the above copyright
#          notice, this list of conditions and the following disclaimer.
#        * Redistributions in binary form must reproduce the above copyright
#          notice, this list of conditions and the following disclaimer in the
#          documentation and/or other materials provided with the distribution.
#        * Neither the name of EURid nor the names of its contributors may be
#          used to endorse or promote products derived from this software
#          without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
################################################################################

cmake_minimum_required(VERSION 3.22)
project(dnsdb LANGUAGES C)

include(${CMAKE_SOURCE_DIR}/cmake/EURidToolbox.cmake)

set(CMAKE_C_STANDARD 11)
set(LIBRARY_SO_VERSION 10.0.0)
set(LIBRARY_SO_MAJOR 10)

set(PACKAGE "dnsdb")

kvstatus("building" "${PACKAGE}")

add_definitions(-DDNSDB_BUILD)

################################################################################
#
#       SOURCES
#
################################################################################

set(LIBRARY_SOURCE_PATH "src")
set(LIBRARY_HEADER_PATH "include/dnsdb")
set(LIBRARY_CONFIG_FILE "dnsdb_config.h")
set(LIBRARY_FEATURES_FILE "zdb_config_features.h")
set(LIBRARY_FEATURES_PREFIX "ZDB_")

set(LIBRARY_SOURCES
        ${LIBRARY_SOURCE_PATH}/avl.c
        ${LIBRARY_SOURCE_PATH}/dictionary.c
        ${LIBRARY_SOURCE_PATH}/dictionary_btree.c
        ${LIBRARY_SOURCE_PATH}/dictionary_htbt.c
        ${LIBRARY_SOURCE_PATH}/htable.c
        ${LIBRARY_SOURCE_PATH}/htbt.c
		${LIBRARY_SOURCE_PATH}/journal_cjf.c
        ${LIBRARY_SOURCE_PATH}/journal_cjf_idxt.c
        ${LIBRARY_SOURCE_PATH}/journal_cjf_page_cache.c
        ${LIBRARY_SOURCE_PATH}/journal_cjf_page_output_stream.c
        ${LIBRARY_SOURCE_PATH}/journal_cjf_page.c
		${LIBRARY_SOURCE_PATH}/journal_cjf_ro.c
        ${LIBRARY_SOURCE_PATH}/journal.c
        ${LIBRARY_SOURCE_PATH}/journal_ix.c
        ${LIBRARY_SOURCE_PATH}/journal_jnl.c
        ${LIBRARY_SOURCE_PATH}/xfr_copy.c

		${LIBRARY_SOURCE_PATH}/zdb_zone_resource_record.c
		${LIBRARY_SOURCE_PATH}/zdb_zone_resource_record_set.c
		${LIBRARY_SOURCE_PATH}/zdb_zone_resource_record_sets.c
		${LIBRARY_SOURCE_PATH}/zdb_zone_resource_record_sets_collection.c

        ${LIBRARY_SOURCE_PATH}/zdb_zone_answer_axfr.c
        ${LIBRARY_SOURCE_PATH}/zdb_zone_answer_ixfr.c
        ${LIBRARY_SOURCE_PATH}/zdb_zone_arc.c
		#${LIBRARY_SOURCE_PATH}/zdb_zone_diff.c
        ${LIBRARY_SOURCE_PATH}/zdb_zone_dnssec.c
        ${LIBRARY_SOURCE_PATH}/zdb_zone_find.c
        ${LIBRARY_SOURCE_PATH}/zdb_zone_garbage.c
        ${LIBRARY_SOURCE_PATH}/zdb_zone_journal.c
        ${LIBRARY_SOURCE_PATH}/zdb_zone_lock.c
        ${LIBRARY_SOURCE_PATH}/zdb_zone_lock_monitor.c
        ${LIBRARY_SOURCE_PATH}/zdb_zone_path_provider.c
        ${LIBRARY_SOURCE_PATH}/zdb_zone_reader_filter.c
        ${LIBRARY_SOURCE_PATH}/zdb.c
        ${LIBRARY_SOURCE_PATH}/zdb_cache.c
        ${LIBRARY_SOURCE_PATH}/zdb_error.c
        ${LIBRARY_SOURCE_PATH}/zdb_icmtl.c
		${LIBRARY_SOURCE_PATH}/zdb_query_to_wire.c
		${LIBRARY_SOURCE_PATH}/zdb_query_to_wire_append.c
		${LIBRARY_SOURCE_PATH}/zdb_query_to_wire_append_nsec.c
		${LIBRARY_SOURCE_PATH}/zdb_query_to_wire_append_nsec3.c
		${LIBRARY_SOURCE_PATH}/zdb_query_to_wire_append_soa.c
		${LIBRARY_SOURCE_PATH}/zdb_query_to_wire_append_type_rrsigs.c
		${LIBRARY_SOURCE_PATH}/zdb_record.c
        ${LIBRARY_SOURCE_PATH}/zdb_rr_label.c
        ${LIBRARY_SOURCE_PATH}/zdb_sanitize.c
        ${LIBRARY_SOURCE_PATH}/zdb_zone.c
        ${LIBRARY_SOURCE_PATH}/zdb_zone_axfr_input_stream.c
        ${LIBRARY_SOURCE_PATH}/zdb_zone_label.c
        ${LIBRARY_SOURCE_PATH}/zdb_zone_label_iterator.c
		${LIBRARY_SOURCE_PATH}/zdb_zone_label_iterator_ex.c
        ${LIBRARY_SOURCE_PATH}/zdb_zone_load.c
        ${LIBRARY_SOURCE_PATH}/zdb_zone_process.c
        ${LIBRARY_SOURCE_PATH}/zdb_zone_store_axfr.c
		${LIBRARY_SOURCE_PATH}/zdb_zone_store_czf.c
        ${LIBRARY_SOURCE_PATH}/zdb_zone_write_text.c
        ${LIBRARY_SOURCE_PATH}/zdb_zone_write_unbound.c
)

set(LIBRARY_HEADERS
        ${LIBRARY_HEADER_PATH}/avl.h
        ${LIBRARY_HEADER_PATH}/btree.h
        ${LIBRARY_HEADER_PATH}/dictionary.h
        ${LIBRARY_HEADER_PATH}/dictionary_node.h
        ${LIBRARY_HEADER_PATH}/dnsrdata.h
        ${LIBRARY_HEADER_PATH}/dnssec.h
        ${LIBRARY_HEADER_PATH}/dnssec_config.h
        ${LIBRARY_HEADER_PATH}/dnssec_keystore.h
        ${LIBRARY_HEADER_PATH}/htable.h
        ${LIBRARY_HEADER_PATH}/htbt.h
        ${LIBRARY_HEADER_PATH}/journal_cjf.h
        ${LIBRARY_HEADER_PATH}/journal_cjf_common.h
        ${LIBRARY_HEADER_PATH}/journal_cjf_idxt.h
        ${LIBRARY_HEADER_PATH}/journal_cjf_page.h
        ${LIBRARY_HEADER_PATH}/journal_cjf_page_cache.h
        ${LIBRARY_HEADER_PATH}/journal_cjf_page_output_stream.h
        ${LIBRARY_HEADER_PATH}/journal.h
        ${LIBRARY_HEADER_PATH}/journal_ix.h
        ${LIBRARY_HEADER_PATH}/journal_jnl.h
        ${LIBRARY_HEADER_PATH}/chain_replay.h
        ${LIBRARY_HEADER_PATH}/nsec.h
        ${LIBRARY_HEADER_PATH}/nsec_chain_replay.h
        ${LIBRARY_HEADER_PATH}/nsec3.h
        ${LIBRARY_HEADER_PATH}/nsec3_collection.h
        ${LIBRARY_HEADER_PATH}/nsec3_chain_replay.h
        ${LIBRARY_HEADER_PATH}/nsec3_item.h
        ${LIBRARY_HEADER_PATH}/nsec3_load.h
        ${LIBRARY_HEADER_PATH}/nsec3_owner.h
        ${LIBRARY_HEADER_PATH}/nsec3_types.h
        ${LIBRARY_HEADER_PATH}/nsec3_zone.h
        ${LIBRARY_HEADER_PATH}/nsec_collection.h
        ${LIBRARY_HEADER_PATH}/nsec_common.h
        ${LIBRARY_HEADER_PATH}/rrsig.h
        ${LIBRARY_HEADER_PATH}/xfr_copy.h
        ${LIBRARY_HEADER_PATH}/zdb.h
        ${LIBRARY_HEADER_PATH}/zdb_config.h
        ${LIBRARY_HEADER_PATH}/zdb_error.h
        ${LIBRARY_HEADER_PATH}/zdb_icmtl.h
		${LIBRARY_HEADER_PATH}/zdb_query_to_wire.h
		${LIBRARY_HEADER_PATH}/zdb_query_to_wire_append.h
		${LIBRARY_HEADER_PATH}/zdb_query_to_wire_append_nsec.h
		${LIBRARY_HEADER_PATH}/zdb_query_to_wire_append_nsec3.h
		${LIBRARY_HEADER_PATH}/zdb_query_to_wire_append_soa.h
		${LIBRARY_HEADER_PATH}/zdb_query_to_wire_append_type_rrsigs.h
		${LIBRARY_HEADER_PATH}/zdb_query_to_wire_context.h
        ${LIBRARY_HEADER_PATH}/zdb_record.h
        ${LIBRARY_HEADER_PATH}/zdb_rr_label.h
        ${LIBRARY_HEADER_PATH}/zdb_sanitize.h
		${LIBRARY_HEADER_PATH}/zdb_ttlrdata.h
        ${LIBRARY_HEADER_PATH}/zdb_types.h
        ${LIBRARY_HEADER_PATH}/zdb_cache.h
        ${LIBRARY_HEADER_PATH}/zdb_zone.h
        ${LIBRARY_HEADER_PATH}/zdb_lock.h
        ${LIBRARY_HEADER_PATH}/zdb_zone_arc.h
        ${LIBRARY_HEADER_PATH}/zdb_zone_dnssec.h
        ${LIBRARY_HEADER_PATH}/zdb_zone_find.h
        ${LIBRARY_HEADER_PATH}/zdb_zone_garbage.h
        ${LIBRARY_HEADER_PATH}/zdb_zone_journal.h
        ${LIBRARY_HEADER_PATH}/zdb_zone_lock.h
        ${LIBRARY_HEADER_PATH}/zdb_zone_lock_monitor.h
        ${LIBRARY_HEADER_PATH}/zdb_zone_answer_axfr.h
        ${LIBRARY_HEADER_PATH}/zdb_zone_answer_ixfr.h
        ${LIBRARY_HEADER_PATH}/zdb_zone_maintenance.h
        ${LIBRARY_HEADER_PATH}/zdb_packed_ttlrdata.h
        ${LIBRARY_HEADER_PATH}/zdb_zone_axfr_input_stream.h
        ${LIBRARY_HEADER_PATH}/zdb_zone_label.h
        ${LIBRARY_HEADER_PATH}/zdb_zone_label_iterator.h
		${LIBRARY_HEADER_PATH}/zdb_zone_label_iterator_ex.h
        ${LIBRARY_HEADER_PATH}/zdb_zone_load.h
        ${LIBRARY_HEADER_PATH}/zdb_zone_path_provider.h
        ${LIBRARY_HEADER_PATH}/zdb_zone_process.h
        ${LIBRARY_HEADER_PATH}/zdb_zone_reader_filter.h
		${LIBRARY_HEADER_PATH}/zdb_zone_resource_record.h
		${LIBRARY_HEADER_PATH}/zdb_zone_resource_record_set.h
		${LIBRARY_HEADER_PATH}/zdb_zone_resource_record_sets.h
        ${LIBRARY_HEADER_PATH}/zdb_zone_write.h
        ${LIBRARY_HEADER_PATH}/nsec3_forall_label.h
)


kvstatus("HAS_DYNUPDATE_SUPPORT" "${HAS_DYNUPDATE_SUPPORT}")
if(HAS_DYNUPDATE_SUPPORT)
    set(LIBRARY_SOURCES
        ${LIBRARY_SOURCES}
        ${LIBRARY_SOURCE_PATH}/dynupdate_check_prerequisites.c
        ${LIBRARY_SOURCE_PATH}/dynupdate_diff.c
        ${LIBRARY_SOURCE_PATH}/dynupdate_diff_nochain.c
        ${LIBRARY_SOURCE_PATH}/dynupdate_diff_nsec.c
        ${LIBRARY_SOURCE_PATH}/dynupdate_diff_nsec3.c
		${LIBRARY_SOURCE_PATH}/dynupdate_message.c
        ${LIBRARY_SOURCE_PATH}/zdb_zone_maintenance.c
        ${LIBRARY_SOURCE_PATH}/zdb_zone_maintenance_rrsig.c
        ${LIBRARY_SOURCE_PATH}/zdb_zone_maintenance_nsec.c
        ${LIBRARY_SOURCE_PATH}/zdb_zone_maintenance_nsec3.c
	)
    set(LIBRARY_HEADERS
        ${LIBRARY_HEADERS}
	    ${LIBRARY_HEADER_PATH}/dynupdate.h
	    ${LIBRARY_HEADER_PATH}/dynupdate_diff.h
		${LIBRARY_HEADER_PATH}/dynupdate_message.h
    )
endif()

kvstatus("HAS_DNSSEC_SUPPORT" "${HAS_DNSSEC_SUPPORT}")
if(HAS_DNSSEC_SUPPORT)
		set(LIBRARY_SOURCES
        ${LIBRARY_SOURCES}
        ${LIBRARY_SOURCE_PATH}/dnssec.c
        ${LIBRARY_SOURCE_PATH}/dnssec_keystore.c
        ${LIBRARY_SOURCE_PATH}/nsec_common.c
        ${LIBRARY_SOURCE_PATH}/rrsig.c
        ${LIBRARY_SOURCE_PATH}/zdb_packed_ttlrdata.c
    )
endif()

kvstatus("HAS_NSEC3_SUPPORT" "${HAS_NSEC3_SUPPORT}")
if(HAS_NSEC3_SUPPORT)
		set(LIBRARY_SOURCES
        ${LIBRARY_SOURCES}
        ${LIBRARY_SOURCE_PATH}/nsec3.c
        ${LIBRARY_SOURCE_PATH}/nsec3_collection.c
        ${LIBRARY_SOURCE_PATH}/nsec3_item.c
        ${LIBRARY_SOURCE_PATH}/nsec3_chain_replay.c
        ${LIBRARY_SOURCE_PATH}/nsec3_load.c
        ${LIBRARY_SOURCE_PATH}/nsec3_owner.c
        ${LIBRARY_SOURCE_PATH}/nsec3_zone.c
        ${LIBRARY_SOURCE_PATH}/nsec3_forall_label.c
    )

		set(LIBRARY_HEADERS
        ${LIBRARY_HEADERS}
#        ${LIBRARY_HEADER_PATH}/nsec3.h
#        ${LIBRARY_HEADER_PATH}/nsec3_collection.h
#        ${LIBRARY_HEADER_PATH}/nsec3_hash.h
#        ${LIBRARY_HEADER_PATH}/nsec3_item.h
#        ${LIBRARY_HEADER_PATH}/nsec3_load.h
#        ${LIBRARY_HEADER_PATH}/nsec3_owner.h
#        ${LIBRARY_HEADER_PATH}/nsec3_types.h
#        ${LIBRARY_HEADER_PATH}/nsec3_zone.h
    )
endif()

if(HAS_NSEC_SUPPORT)
		set(LIBRARY_SOURCES
        ${LIBRARY_SOURCES}
        ${LIBRARY_SOURCE_PATH}/nsec.c
		${LIBRARY_SOURCE_PATH}/nsec_chain_replay.c
        ${LIBRARY_SOURCE_PATH}/nsec_collection.c
    )

		set(LIBRARY_HEADERS
        ${LIBRARY_HEADERS}
#        ${LIBRARY_HEADER_PATH}/nsec.h
#        ${LIBRARY_HEADER_PATH}/nsec_collection.h
#        ${LIBRARY_HEADER_PATH}/nsec_common.h
    )
endif()

# add itself as search path
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include")
include_directories("${CMAKE_CURRENT_BINARY_DIR}/include")

################################################################################
#
# Config & features
#
################################################################################

=== lib/dnslg/CMakeLists.txt ===
################################################################################
#
# Copyright (c) 2011-2024, EURid vzw. All rights reserved.
# The YADIFA TM software product is provided under the BSD 3-clause license:
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
#        * Redistributions of source code must retain the above copyright
#          notice, this list of conditions and the following disclaimer.
#        * Redistributions in binary form must reproduce the above copyright
#          notice, this list of conditions and the following disclaimer in the
#          documentation and/or other materials provided with the distribution.
#        * Neither the name of EURid nor the names of its contributors may be
#          used to endorse or promote products derived from this software
#          without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
################################################################################

cmake_minimum_required(VERSION 3.22)

project(dnslg LANGUAGES C)
set(CMAKE_C_STANDARD 11)
set(LIBRARY_SO_VERSION                       10.0.0)
set(LIBRARY_SO_MAJOR                             10)

set(PACKAGE "dnslg")

kvstatus("building" "${PACKAGE}")

add_definitions(-DDNSLG_BUILD)

################################################################################
#
#       SOURCES
#
################################################################################

set(LIBRARY_SOURCE_PATH "src")
set(LIBRARY_HEADER_PATH "include/dnslg")
set(LIBRARY_CONFIG_FILE "dnslg_config.h")
set(LIBRARY_FEATURES_FILE "dnslg_config_features.h")
set(LIBRARY_FEATURES_PREFIX "DNSLG_")

set(LIBRARY_SOURCES
    ${LIBRARY_SOURCE_PATH}/config_load.c
    ${LIBRARY_SOURCE_PATH}/config_resolver.c
    ${LIBRARY_SOURCE_PATH}/dns.c
    ${LIBRARY_SOURCE_PATH}/resolv_conf.c
    ${LIBRARY_SOURCE_PATH}/resolv.c
)

set(LIBRARY_HEADERS
    ${LIBRARY_HEADER_PATH}/config_load.h
    ${LIBRARY_HEADER_PATH}/config_resolver.h
    ${LIBRARY_HEADER_PATH}/dns.h
    ${LIBRARY_HEADER_PATH}/resolv_conf.h
    ${LIBRARY_HEADER_PATH}/resolv.h
)

# add itself as search path
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include")
include_directories("${CMAKE_CURRENT_BINARY_DIR}/include")

################################################################################
#
# Config & features
#
################################################################################

kvstatus("creating" "${LIBRARY_HEADER_PATH}/${LIBRARY_CONFIG_FILE}")
configure_file("${LIBRARY_CONFIG_FILE}.cmake.in" "${LIBRARY_HEADER_PATH}/${LIBRARY_CONFIG_FILE}")

kvstatus("creating" "${LIBRARY_FEATURES_FILE}")
prefixes_configure_file("${CMAKE_CURRENT_BINARY_DIR}/${LIBRARY_HEADER_PATH}/${LIBRARY_CONFIG_FILE}" "${CMAKE_CURRENT_BINARY_DIR}/${LIBRARY_HEADER_PATH}/${LIBRARY_FEATURES_FILE}" "${LIBRARY_FEATURES_PREFIX}")
set(LIBRARY_HEADERS ${LIBRARY_HEADERS} "${CMAKE_CURRENT_BINARY_DIR}/${LIBRARY_HEADER_PATH}/${LIBRARY_FEATURES_FILE}")

################################################################################
#
# Dependencies
#
################################################################################

include_directories("${CMAKE_SOURCE_DIR}/lib/dnscore/include")
include_directories("${CMAKE_BINARY_DIR}/lib/dnscore/include")

set(DNSLG_LIBRARIES_DEPS ${DNSCORELIB_NAME})

kvstatus("DNSLG_LIBRARIES_DEPS" "${DNSLG_LIBRARIES_DEPS}")

################################################################################
#
# Targets
#
################################################################################

if(BUILD_SHARED_LIBS)
    kvstatus("dnslg build" "shared")
    add_library(dnslg SHARED             ${LIBRARY_SOURCES} ${LIBRARY_HEADERS})
    link_directories("${CMAKE_INSTALL_PREFIX}/lib")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${C_COMMON_FLAGS} ${C_LIBRARY_FLAGS}")
    set_target_properties(dnslg PROPERTIES SOVERSION ${LIBRARY_SO_VERSION})
    set_target_properties(dnslg PROPERTIES VERSION ${LIBRARY_SO_MAJOR})
    target_link_libraries(dnslg ${DNSLG_LIBRARIES_DEPS})
endif()

if(BUILD_STATIC_LIBS)
    kvstatus("dnslg build" "static")
    add_library(dnslg-static STATIC ${LIBRARY_SOURCES} ${LIBRARY_HEADERS})
    set_target_properties(dnslg-static PROPERTIES OUTPUT_NAME dnslg)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${C_COMMON_FLAGS} ${C_LIBRARY_FLAGS}")

    link_directories("${CMAKE_INSTALL_PREFIX}/lib")
    target_link_libraries(dnslg-static ${DNSLG_LIBRARIES_DEPS})
endif()


kvstatus("making ${PACKAGE}" "done")

################################################################################
#
# Installation
#
################################################################################

if(BUILD_SHARED_LIBS)
    kvstatus("install" "${PACKAGE} shared libray")
    install(TARGETS dnslg LIBRARY DESTINATION "${CMAKE_INSTALL_FULL_LIBDIR}")
    set(DNSLGLIB_NAME "dnslg" CACHE STRING "dnslg library name" FORCE)
endif()

if(BUILD_STATIC_LIBS)
    kvstatus("install" "${PACKAGE} static library")
    install(TARGETS dnslg-static LIBRARY DESTINATION "${CMAKE_INSTALL_FULL_LIBDIR}")
    set(DNSLGLIB_NAME "dnslg-static" CACHE STRING "dnslg library name" FORCE)
endif()

install(FILES ${LIBRARY_HEADERS} DESTINATION "${CMAKE_INSTALL_FULL_INCLUDEDIR}/dnslg")

=== sbin/yadifad/CMakeLists.txt ===
################################################################################
#
# Copyright (c) 2011-2024, EURid vzw. All rights reserved.
# The YADIFA TM software product is provided under the BSD 3-clause license:
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
#        * Redistributions of source code must retain the above copyright
#          notice, this list of conditions and the following disclaimer.
#        * Redistributions in binary form must reproduce the above copyright
#          notice, this list of conditions and the following disclaimer in the
#          documentation and/or other materials provided with the distribution.
#        * Neither the name of EURid nor the names of its contributors may be
#          used to endorse or promote products derived from this software
#          without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
################################################################################

cmake_minimum_required(VERSION 3.22)

project(yadifad LANGUAGES C)

set(PACKAGE "yadifad")

kvstatus("building" "${PACKAGE}")

################################################################################
#
#       SOURCES
#
################################################################################

set(YADIFAD_SOURCES
    yadifad.c
    axfr.c
    config_main.c
    config_zone.c
    confs.c
    database_service_zone_desc_load.c
    database_service_zone_desc_unload.c
    database_service_zone_download.c
    database_service_zone_freeze.c
    database_service_zone_load.c
    database_service_zone_mount.c
    database_service_zone_store.c
    database_service_zone_unfreeze.c
    database_service_zone_unload.c
    database_service_zone_unmount.c
    database_service.c
    database.c
    ixfr.c
    log_query.c
    log_statistics.c
    notify.c
    poll_util.c
    process_class_ch.c
    server.c
    server_context.c
    server_dns_tcp.c
    server_dns_tls.c
    server_rndc.c
    server_process_message_common.c
    server_process_message_tcp.c
    server_process_message_udp.c
    signals.c
    zone.c
)
if(WIN32)
message("Windows variant")
set(YADIFAD_SOURCES ${YADIFAD_SOURCES}
    server_sm.c
)
elseif(APPLE)
message("OSX variant")
set(YADIFAD_SOURCES ${YADIFAD_SOURCES}
    server_sm.c
    server_rw.c
)
elseif(${CMAKE_SYSTEM_NAME} STREQUAL "OpenBSD")
message("OpenBSD")
set(YADIFAD_SOURCES ${YADIFAD_SOURCES}
    server_sm.c
    server_rw.c
)
else()
message("UNIX variant")
set(YADIFAD_SOURCES ${YADIFAD_SOURCES}
    server_rw.c
    server_sm.c
    server_mm.c
)
endif()
set(YADIFAD_HEADERS
    yadifad.h
    axfr.h
    config_error.h
    confs.h
    database_service_zone_desc_load.h
    database_service_zone_desc_unload.h
    database_service_zone_download.h
    database_service_zone_freeze.h
    database_service_zone_load.h
    database_service_zone_mount.h
    database_service_zone_store.h
    database_service_zone_unfreeze.h
    database_service_zone_unload.h
    database_service_zone_unmount.h
    database_service.h
    database.h
    dnssec_policy.h
    ixfr.h
    log_query.h
    log_statistics.h
    notify.h
    poll_util.h
    process_class_ch.h
    server.h
    server_context.h
    server_dns_tcp.h
    server_dns_tls.h
    server_rndc.h
    server_error.h
    server_process_message_common.h
    signals.h
    zone.h
    zone_desc.h
    zone_source.h
)
if(WIN32)
elseif(APPLE)
set(YADIFAD_SOURCES ${YADIFAD_SOURCES}
    server_rw.h
    server_sm.h
)
else()
set(YADIFAD_SOURCES ${YADIFAD_SOURCES}
    server_rw.h
    server_mm.h
    server_sm.h
)
endif()

kvstatus("HAS_NSID_SUPPORT" "${HAS_NSID_SUPPORT}")

if(HAS_NSID_SUPPORT)
    set(YADIFAD_SOURCES
        ${YADIFAD_SOURCES}
        config_nsid.c
    )
endif()
kvstatus("HAS_TCL" "${HAS_TCL}")

if(HAS_TCL)
    set(YADIFAD_SOURCES
    	${YADIFAD_SOURCES}
    		server_shell.c
    )
    set(YADIFAD_HEADERS
    		${YADIFAD_HEADERS}
    		server_shell.h
    )
endif()

kvstatus("HAS_CTRL" "${HAS_CTRL}")

if(HAS_CTRL)
    set(YADIFAD_SOURCES
        ${YADIFAD_SOURCES}
        config_control.c
        config_rndc.c
        ctrl.c
        ctrl_query.c
        ctrl_zone.c
    )

    set(YADIFAD_HEADERS
        ${YADIFAD_HEADERS}
        ctrl.h
        ctrl_query.h
        ctrl_zone.h
    )

    if(HAS_EXPERIMENTAL)
        set(YADIFAD_SOURCES
            ${YADIFAD_SOURCES}
            ctrl_notify.c
            ctrl_query_axfr.c
            ctrl_query_message.c
            ctrl_update.c
        )

        set(YADIFAD_HEADERS
            ${YADIFAD_HEADERS}
            ctrl_notify.h
            ctrl_query_axfr.h
            ctrl_query_message.h
            ctrl_update.h
        )
    endif()
endif()

kvstatus("HAS_EXPERIMENTAL" "${HAS_EXPERIMENTAL}")
kvstatus("HAS_ACL_SUPPORT" "${HAS_ACL_SUPPORT}")

kvstatus("HAS_RRL_SUPPORT" "${HAS_RRL_SUPPORT}")

if(HAS_RRL_SUPPORT)
    set(YADIFAD_SOURCES
        ${YADIFAD_SOURCES}
        rrl.c
    )

    set(YADIFAD_HEADERS
        ${YADIFAD_HEADERS}
        rrl.h
    )
endif()


kvstatus("HAS_DYNUPDATE_SUPPORT" "${HAS_DYNUPDATE_SUPPORT}")
if(HAS_DYNUPDATE_SUPPORT)
    set(YADIFAD_SOURCES
        ${YADIFAD_SOURCES}
        dynupdate_query_service.c
    )

    set(YADIFAD_HEADERS
        ${YADIFAD_HEADERS}
        dynupdate_query_service.h
    )
endif()

if(HAS_DNSSEC_SUPPORT)
    kvstatus("HAS_RRSIG_MANAGEMENT_SUPPORT" "${HAS_RRSIG_MANAGEMENT_SUPPORT}")
    if(HAS_RRSIG_MANAGEMENT_SUPPORT)
        set(YADIFAD_SOURCES
            ${YADIFAD_SOURCES}
    			config_denial.c
                config_dnssec_policy.c
                config_key_roll.c
                config_key_roll_parser.c
                config_key_suite.c
                config_key_template.c
    			database_service_zone_resignature.c
                zone_signature_date_next.c
                zone_signature_date_prev.c
                zone_signature_policy.c
        )

        set(YADIFAD_HEADERS
            ${YADIFAD_HEADERS}
    			database_service_zone_resignature.h
    			config_dnssec_policy.h
    			config_key_roll_parser.h
    			zone_signature_policy.h
        )
    endif()
endif()

kvstatus("HAS_EVENT_DYNAMIC_MODULE" "${HAS_EVENT_DYNAMIC_MODULE}")
if(HAS_EVENT_DYNAMIC_MODULE)
    set(YADIFAD_SOURCES ${YADIFAD_SOURCES}
        dynamic_module_handler.c
    )
    set(YADIFAD_SOURCES ${YADIFAD_SOURCES}
        dynamic_module_handler.h
        dynamic_module_interface.h
    )
endif()

kvstatus("HAS_DYNCONF_SUPPORT" "${HAS_DYNCONF_SUPPORT}")
if(HAS_DYNCONF_SUPPORT)
    set(YADIFAD_SOURCES
        ${YADIFAD_SOURCES}
        dynconf.c
    )

    set(YADIFAD_HEADERS
        ${YADIFAD_HEADERS}
        dynconf.h
    )
endif()

configure_file(server_config.h.cmake.in server_config.h)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})

################################################################################
#
#       SEARCH EXTERNAL LIBRARIES
#
################################################################################

# yadifad needs:
#   - dnscore
#   - dnsdb
#
# maybe:
#   - dnstcl
#

# add headers of yadifad libraries in the search path
include_directories("${CMAKE_SOURCE_DIR}/lib/dnscore/include")
include_directories("${CMAKE_BINARY_DIR}/lib/dnscore/include")

include_directories("${CMAKE_SOURCE_DIR}/lib/dnsdb/include")
include_directories("${CMAKE_BINARY_DIR}/lib/dnsdb/include")

#set(YADIFA_LIBRARIES
#LINK_PUBLIC dnscore
#		LINK_PRIVATE dnsdb)

buildinfo_file("${CMAKE_BINARY_DIR}/lib/dnsdb/include/buildinfo.h")

kvstatus("HAS_TCL IN YADIFAD" "${HAS_TCL}\n")
if(HAS_TCL)

    # if 'Tcl' found
    find_package(Tcl REQUIRED)
    include_directories("${CMAKE_SOURCE_DIR}/lib/dnstcl/include")

    set(YADIFAD_LIBRARIES_DEPS ${TCL_LIB})

    set(YADIFAD_SOURCES
        ${YADIFAD_SOURCES}
        server-shell.c
    )

    set(YADIFAD_HEADERS
        ${YADIFAD_HEADERS}
        server-shell.h
    )
else()
    #
endif()

# this is only to check the include path if there are some issues
# no need to add libcrypto and libssl in the linking this is done with dnscore
# find_package(Openssl REQUIRED)

################################################################################
#
# Target
#
################################################################################

add_library(yadifad-lib STATIC ${YADIFAD_SOURCES} ${YADIFAD_HEADERS})

# link it with other libraries
#     - from YADIFA 'dnscore'
#     - from YADIFA 'db'
#     - from YADIFA 'dnszone'
#     - from YADIFA 'dnstcl' (maybe)

# Set it up globally
#
#if(APPLE)
#    set(CMAKE_MACOSX_RPATH 1)
#endif()
#set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${C_COMMON_FLAGS}")

link_directories("${CMAKE_INSTALL_PREFIX}/lib")

target_link_libraries(yadifad-lib PUBLIC ${DNSDBLIB_NAME} ${DNSCORELIB_NAME})

add_executable(yadifad main.c)
target_link_libraries(yadifad PUBLIC yadifad-lib)

kvstatus("built" "${PACKAGE}")

################################################################################
#
# Installation
#
################################################################################

install(TARGETS yadifad RUNTIME DESTINATION "${CMAKE_INSTALL_FULL_SBINDIR}")

=== sbin/yakeyrolld/CMakeLists.txt ===
################################################################################
#
# Copyright (c) 2011-2024, EURid vzw. All rights reserved.
# The YADIFA TM software product is provided under the BSD 3-clause license:
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
#        * Redistributions of source code must retain the above copyright
#          notice, this list of conditions and the following disclaimer.
#        * Redistributions in binary form must reproduce the above copyright
#          notice, this list of conditions and the following disclaimer in the
#          documentation and/or other materials provided with the distribution.
#        * Neither the name of EURid nor the names of its contributors may be
#          used to endorse or promote products derived from this software
#          without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
################################################################################

cmake_minimum_required(VERSION 3.22)

# include(${CMAKE_SOURCE_DIR}/cmake/FindYADIFA.cmake)

get_filename_component(AUTO_NAME ${CMAKE_CURRENT_SOURCE_DIR} NAME)

message("Building test: ${AUTO_NAME}")

project(${AUTO_NAME} LANGUAGES C)

# FindYADIFA(DNSCORE DNSDB SEARCH_PATHS ../lib/dnscore ../lib/dnsdb)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${C_COMMON_FLAGS}")

configure_file(keyroll_config.h.cmake.in keyroll_config.h)

include_directories(${YADIFA_INCLUDE_DIRS})

include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})

include_directories("${CMAKE_SOURCE_DIR}/lib/dnscore/include")
include_directories("${CMAKE_BINARY_DIR}/lib/dnscore/include")

include_directories("${CMAKE_SOURCE_DIR}/lib/dnsdb/include")
include_directories("${CMAKE_BINARY_DIR}/lib/dnsdb/include")

add_executable(${PROJECT_NAME} main.c keyroll.c keyroll.h dnssec_policy.c dnssec_policy.h date_next.c date_prev.c
        config_dnssec_policy.c config_dnssec_policy.h config_key_roll_parser.c config_key_roll_parser.h
        config_key_roll.c config_key_suite.c config_key_template.c rest_server.c
        )

target_link_libraries(${PROJECT_NAME} PUBLIC ${DNSDBLIB_NAME} ${DNSCORELIB_NAME})

install(TARGETS ${PROJECT_NAME} RUNTIME DESTINATION "${CMAKE_INSTALL_FULL_SBINDIR}")

=== tests/circular-file-test/CMakeLists.txt ===
################################################################################
#
# Copyright (c) 2011-2024, EURid vzw. All rights reserved.
# The YADIFA TM software product is provided under the BSD 3-clause license:
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
#        * Redistributions of source code must retain the above copyright
#          notice, this list of conditions and the following disclaimer.
#        * Redistributions in binary form must reproduce the above copyright
#          notice, this list of conditions and the following disclaimer in the
#          documentation and/or other materials provided with the distribution.
#        * Neither the name of EURid nor the names of its contributors may be
#          used to endorse or promote products derived from this software
#          without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
################################################################################

cmake_minimum_required(VERSION 3.22)

# include(${CMAKE_SOURCE_DIR}/cmake/FindYADIFA.cmake)

get_filename_component(AUTO_NAME ${CMAKE_CURRENT_SOURCE_DIR} NAME)

message("Building test: ${AUTO_NAME}")

project(${AUTO_NAME} LANGUAGES C)

# FindYADIFA(DNSCORE DNSDB SEARCH_PATHS ../../lib/dnscore ../../lib/dnsdb)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${C_COMMON_FLAGS}")

include_directories(${YADIFA_INCLUDE_DIRS})

include_directories("${CMAKE_SOURCE_DIR}/lib/dnscore/include")
include_directories("${CMAKE_BINARY_DIR}/lib/dnscore/include")

include_directories("${CMAKE_SOURCE_DIR}/lib/dnsdb/include")
include_directories("${CMAKE_BINARY_DIR}/lib/dnsdb/include")

add_executable(${PROJECT_NAME} main.c)

target_link_libraries(${PROJECT_NAME} ${DNSDBLIB_NAME} ${DNSCORELIB_NAME})

## yadifa 2.1.6

=== debian/changelog ===
yadifa (2.1.6-1) unstable; urgency=low

  * New upstream version 2.1.6
  * Changed Vcs-Git URI to https
  * Refreshed no-compiledate patches
  * Re-add patch fixing spelling errors
  * Add CPPFLAGS to properly produce dbgsym package
  * Re-order/fix configure options (tools) and enable dynamic provisioning
  * Declare compliance with Debian policy 3.9.7

 -- Markus Schade <markus.schade@gmail.com>  Fri, 19 Feb 2016 12:45:30 +0100

yadifa (2.1.4-2) unstable; urgency=low

  * Extend no-compile-date patch to make the build reproducible again.
    Courtesy of Reiner Herrmann. (Closes: #803139)

 -- Markus Schade <markus.schade@gmail.com>  Tue, 27 Oct 2015 11:39:00 +0100

yadifa (2.1.4-1) unstable; urgency=low

  * New upstream version 2.1.4

 -- Markus Schade <markus.schade@gmail.com>  Mon, 26 Oct 2015 15:00:10 +0100

yadifa (2.1.3-2) unstable; urgency=low

  * Add debian/patches/do-not-use-or-define-the-compile-date.patch
    to make the build reproducible. Courtesy of Santiago Vila
    (Closes: #798450)

 -- Markus Schade <markus.schade@gmail.com>  Wed, 09 Sep 2015 15:12:24 +0200

yadifa (2.1.3-1) unstable; urgency=low

  * New upstream version 2.1.3
  * Refresh patches for version 2.1.3
  * Add hardening flags to build

 -- Markus Schade <markus.schade@gmail.com>  Mon, 07 Sep 2015 19:31:05 +0200

yadifa (2.1.1-1) unstable; urgency=low

  * Initial release (Closes: #682716)

 -- Markus Schade <markus.schade@gmail.com>  Sun, 16 Aug 2015 15:54:44 +0200

=== debian/control ===
Source: yadifa
Section: net
Priority: optional
Maintainer: Markus Schade <markus.schade@gmail.com>
Build-Depends:
 dh-autoreconf,
 debhelper (>= 9),
 dh-systemd,
 libssl-dev
Standards-Version: 3.9.7
Homepage: http://www.yadifa.eu
Vcs-Git: https://github.com/asciiprod/yadifa.git
Vcs-Browser: https://github.com/asciiprod/yadifa.git

Package: yadifa
Architecture: any
Depends:
 adduser,
 debconf,
 lsb-base,
 netbase,
 ${misc:Depends},
 ${shlibs:Depends}
Description: Internet Domain Name Server
 ${Description}
 .
 This package provides the server and related configuration files.

Package: libyadifa-dev
Section: libdevel
Architecture: any
Depends:
 ${misc:Depends}
Description: development libraries and header files for YADIFA
 ${Description}
 .
 This package contains the header files and static libraries needed for
 developing applications for YADIFA. It is currently only used by YADIFA
 itself and should not be considered stable.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_BUILD_MAINT_OPTIONS = hardening=+all,-pie
DEB_CFLAGS_MAINT_APPEND = -Wall -Wextra
DEB_CPPFLAGS_MAINT_APPEND = -DNDEBUG -g
DPKG_EXPORT_BUILDFLAGS = 1
-include /usr/share/dpkg/buildflags.mk

%:
	dh $@  --with autoreconf --with=systemd

override_dh_clean:
	dh_clean
	rm -f debian/substvars

override_dh_auto_configure:
	dh_auto_configure -- \
		--with-tools	\
		--enable-rrl	\
		--enable-nsid	\
		--enable-ctrl	\
		--enable-dynamic-provisioning

override_dh_installinit:
	dh_installinit -a --no-start

override_dh_installman:
	dh_installman --language=C

override_dh_gencontrol:
	for i in $$(sed -n '/^Package:/s/^.* //p' debian/control); do cat debian/vars.in >> debian/$$i.substvars; done
	cat debian/vars.in >> debian/substvars
	dh_gencontrol
